diff -urN asterisk-10.5.1.orig/res/res_agi.c asterisk-10.5.1/res/res_agi.c
--- asterisk-10.5.1.orig/res/res_agi.c	2012-04-17 14:11:25.000000000 -0700
+++ asterisk-10.5.1/res/res_agi.c	2012-07-09 14:20:08.724276301 -0700
@@ -999,10 +999,9 @@
 	.destroy = agi_destroy_commands_cb
 };
 
-static struct agi_cmd *get_agi_cmd(struct ast_channel *chan)
+static int get_agi_cmd(struct ast_channel *chan,struct agi_cmd **cmd)
 {
 	struct ast_datastore *store;
-	struct agi_cmd *cmd;
 	AST_LIST_HEAD(, agi_cmd) *agi_commands;
 
 	ast_channel_lock(chan);
@@ -1011,13 +1010,14 @@
 	if (!store) {
 		ast_log(LOG_ERROR, "Huh? Async AGI datastore disappeared on Channel %s!\n",
 			chan->name);
-		return NULL;
+		*cmd = NULL;
+		return -1;
 	}
 	agi_commands = store->data;
 	AST_LIST_LOCK(agi_commands);
-	cmd = AST_LIST_REMOVE_HEAD(agi_commands, entry);
+	*cmd = AST_LIST_REMOVE_HEAD(agi_commands, entry);
 	AST_LIST_UNLOCK(agi_commands);
-	return cmd;
+	return 0;
 }
 
 /* channel is locked when calling this one either from the CLI or manager thread */
@@ -1318,7 +1318,12 @@
 		 * Process as many commands as we can.  Commands are added via
 		 * the manager or the cli threads.
 		 */
-		while (!hungup && (cmd = get_agi_cmd(chan))) {
+		while (!hungup && !(res=get_agi_cmd(chan,&cmd))) {
+			if (!res) {
+				ast_log(LOG_ERROR, "Failed to get AGI command on channel %s: %s\n",chan->name,strerror(errno));
+				returnstatus = AGI_RESULT_FAILURE;
+				goto async_agi_done;
+			}
 			/* OK, we have a command, let's call the command handler. */
 			cmd_status = agi_handle_command(chan, &async_agi, cmd->cmd_buffer, 0);
